<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <title>학생관리 프로그램</title>
	<script src="//code.jquery.com/jquery-3.5.1.min.js" integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script> 
	<script src="lslib.js"></script>     
  </head>
  <body>

  	<div id="container">
  		<h1>학생관리 프로그램 v1</h1>
  		<div class="program">
  			<ul>
  				<li><a href="#none" onclick="return false;" class="event-insert">학생등록</a></li>
  				<li><a href="#none" onclick="return false;" class="event-allDelete">전체삭제</a></li>
  				<li><a href="#none" class="event-download">다운로드</a></li>
  			</ul>
  		</div>
  		<div class="insert-form">
  			<h2>학생등록</h2>
  			<form id="form-insert">
  				<ul>
					<li>
						<dl>
							<dt>학번</dt>
							<dd><input type="text" name="id" placeholder="학번" value=""></dd>
						</dl>
					</li>
					<li>
						<dl>
							<dt>이름</dt>
							<dd><input type="text" name="name" placeholder="이름" value=""></dd>
						</dl>						
					</li>
					<li>
						<dl>
							<dt>나이</dt>
							<dd><input type="text" name="age" placeholder="나이" value=""></dd>
						</dl>						
					</li>
					<li>
						<dl>
							<dt>성별</dt>
							<dd>
				  				<select name="gender">
				  					<option value="">성별선택</option>
				  					<option value="male">남성</option>
				  					<option value="female">여성</option>
				  				</select>
							</dd>
						</dl>							  						
					</li>
  					<li><input type="submit" value="등록" class="btn submit"></li>
  				</ul>
  				
  			</form>  			
  		</div>
  		<div class="search-form">
  			<h2>검색</h2>
  			<form id="form-search">
  				<ul>
					<li>
						<dl>
							<dt>학번</dt>
							<dd><input type="text" name="id" placeholder="학번" value=""></dd>
						</dl>
					</li>
					<li>
						<dl>
							<dt>이름</dt>
							<dd><input type="text" name="name" placeholder="이름" value=""></dd>
						</dl>						
					</li>  					
  					<li>
  						<input type="submit" class="btn submit" value="검색">
  						<input type="button" class="btn init event-searchInit" value="초기화" style="display:none;">
  					</li>
  				</ul>
  			</form>
  		</div>

  		<div class="list">
  			<h2>목록</h2>
  			<div class="header">
		  		<ul class="item">
  					<li class="id">학번</li>
  					<li class="name">이름</li>
  					<li class="age">나이</li>
  					<li class="gender">성별</li>
  					<li class="reg">등록일</li>
  					<li class="modify">관리</li>
		  		</ul>
  			</div>
  			<div class="items">	
  			</div>
  		</div>  		
  	</div>
  	<textarea id="item-list" class="hidden">
		<ul class="item" data-id="{학번}">
			<li class="id">{학번}</li>
			<li class="name">{이름}</li>
			<li class="age">{나이}</li>
			<li class="gender">{성별}</li>
			<li class="reg">{등록일}</li>
			<li class="modify">{관리}</li>
		</ul>
  	</textarea>

  	<div id="modify">
  		<div class="bg event-modifyClose"></div>
  		<div class="modify-form">
			<h2>정보수정</h2>
			<form id="form-modify">
				<ul>
					<li>
						<dl>
							<dt>학번(수정불가)</dt>
							<dd><input type="text" name="id" placeholder="학번" value="20074869" readonly="" class="readonly"></dd>
						</dl>
					</li>
					<li>
						<dl>
							<dt>이름</dt>
							<dd><input type="text" name="name" placeholder="이름" value="홍길동"></dd>
						</dl>						
					</li>
					<li>
						<dl>
							<dt>나이</dt>
							<dd><input type="text" name="age" placeholder="나이" value="36"></dd>
						</dl>						
					</li>
					<li>
						<dl>
							<dt>성별</dt>
							<dd>
				  				<select name="gender">
				  					<option value="">성별선택</option>
				  					<option value="male">남성</option>
				  					<option value="female">여성</option>
				  				</select>
							</dd>
						</dl>							  						
					</li>
					<li>
						<input type="submit" value="수정" class="btn submit event-modifySubmit">
						<input type="button" value="닫기" class="btn close event-modifyClose">
					</li>
				</ul>
			</form>  		
		</div>	
  	</div>

  	<style>
  		body{box-sizing: border-box;-webkit-box-sizing: border-box;-moz-box-sizing: border-box;word-break: break-all;}
  		h1,h2,h3{ margin:0; padding:0; }
  		ul{ margin:0; padding:0;}
  		ul li{ list-style:none;;}
  		a{ display:inline-block}
  		.hidden{ display:none;}
  		#modify{position: fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 9998; display:none;}
  		body.modify-on #modify{  display:block;}
  		#modify .bg{position: fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 9998;   background:#000; opacity: 0.6;}
  		#modify .modify-form{ position: relative; z-index: 9999; width:100%; max-width:450px; margin:0 auto; background-color:#fff; padding:1%;  margin-top:15%; border:solid 1px #eee;}
  		#modify .modify-form h2{ border-bottom:solid 2px #333; }
  		#modify .modify-form li dt{ font-size:11px; font-weight:900; }
  		#modify .modify-form li:last-child{  border-top:solid 2px #333; padding:10px 0; }
  		#modify .modify-form input.readonly{ background-color:#fafafa; }
  		#modify .modify-form .btn{  border:solid 1px #eee; padding:5px 10px; cursor:pointer;  }
  		#modify .modify-form .btn.submit{ background-color:#333; color:#fff;}
  		#modify .modify-form .btn.close{ background-color:#fafafa; color:#333;}

  		#container{ max-width:850px; margin:50px auto; overflow: hidden;}
  		#container h1{ border-bottom:solid 3px #333; margin:10px 0;  }
  		#container h2{ border-bottom:solid 2px #333; margin:10px 0;  }
  		#container .program{ overflow: hidden; }
  		#container .program ul{ overflow: hidden; margin:0; padding:0;}
  		#container .program li{ list-style: none;margin:0; padding:0; float:left; width:33.33%; background-color:#369; }
  		#container .program li a{ display: inline-block; width:100%; text-align: center; padding:8px 0; text-decoration:none; color:#fff;font-size:13px; font-weight:900; }

  		#container .insert-form{ display:none;}
  		body.insert-on #container .insert-form{ display:block; }
  		#container .insert-form li dt{ font-size:11px; font-weight:900; }
  		#container .insert-form ul li:last-child{ border-top:solid 2px #333; padding:10px 0;  }
  		#container .insert-form .btn{  border:solid 1px #eee; padding:5px 10px; cursor:pointer;  }
  		#container .insert-form .btn.submit{ background-color:#333; color:#fff;}  	

  		#container .search-form li dt{ font-size:11px; font-weight:900; }
  		#container .search-form ul li:last-child{ border-top:solid 2px #333; padding:10px 0;  }
  		#container .search-form .btn{  border:solid 1px #eee; padding:5px 10px; cursor:pointer;  }
  		#container .search-form .btn.submit{ background-color:#333; color:#fff;}  	
  			

  		#container .list ul li{ width:16.66%; float:left;  text-align:center; }
  		#container .list .header ul li{  background-color:#eee; font-weight: 900; padding:10px 0;}
  		#container .list .items ul li{ font-size:14px; padding:5px 0; }
  		#container .list .items ul li a.btn{ padding:2px; text-decoration:none; margin:0 4px; }
  		#container .list .items ul li a.btn.gray{ background: gray; color:#fff; }
  		#container .list .items ul li a.btn.black{ background: black; color:#fff; }
  	</style>
	<script>
	var studentDB = lslib('studentDB');
	var program = {
		searchItems : new Array(),
		config : {
			key : 'std',
			index : new Array('pid','id','name','age','gender','reg','mod'),
			defaultItem : {
				pid : 1,
				id : '',	
				name : '',	
				age : '',	
				gender : '',	
				reg : null,
				mod : '',		
			},		},
		insert : function(){
			try{
				var thisObj = this;
				var $form = $('#form-insert');
				var $id = $form.find('[name="id"]');
				var $name = $form.find('[name="name"]');
				var $age = $form.find('[name="age"]');
				var $gender = $form.find('[name="gender"]');
				var now = thisObj.now();
				var item = thisObj.config.defaultItem;
				var items  = thisObj.get(thisObj.config.key);
				var info  = thisObj.get(thisObj.config.key+'.info');
				item.id = $id.val();
				item.name = $name.val();
				item.age = $age.val();
				item.gender = $gender.val();
				item.reg = now.fullDateTimeStr;
				item.mod = typeof items.mod != 'undefined' && items.mod ? items.mod : '';

				if( item.id == ''){alert("학번을 입력해 주세요."); $id.focus(); return false; }
				if( item.name == ''){alert("학생이름을 입력해 주세요."); $name.focus(); return false; }
				if( item.age == ''){alert("학생나이를 입력해 주세요."); $age.focus(); return false; }
				if( item.gender == ''){alert("학생성별을 선택해 주세요."); $gender.focus(); return false; }

				if( isNaN(item.id) == true || !item.id || parseInt(item.id) < 1  ){ alert("올바른 학번을 입력해주세요(0보다큰 숫자만 입력가능)"); $id.focus(); return false; }
				if( isNaN(item.age) == true || !item.age || parseInt(item.id) < 1 ){ alert("올바른 학생나이를 입력해주세요(0보다큰 숫자만 입력가능)"); $age.focus(); return false; }
				if( $.inArray(item.gender,['male','female']) < 0 ){ alert("올바른 학생성별을 입력해 주세요."); $age.focus(); return false;}

				item.id = parseInt(item.id);
				item.age = parseInt(item.age);
				if( typeof items[item.id] == 'object'){
					alert('이미 등록된 학번입니다.'); return false;
				}

				item.pid = 1;
				if(typeof info.lastPid != 'undefined'){
					item.pid = parseInt(info.lastPid)+1;
				}

				// 학생등록
				items[item.id] = item;
				studentDB.set(thisObj.config.key,items);
				thisObj.indexUpdate(thisObj.config.key);


				$form.find('[name="id"]').val('');
				$form.find('[name="name"]').val('');
				$form.find('[name="age"]').val('');
				$form.find('[name="gender"]').val('');
				$('body').removeClass('insert-on');
				alert('등록이 완료되었습니다.');

				thisObj.view();

			}catch(e){
				console.log(e);
				return studentDB.error("등록에 실패하였습니다.",true);
			}
		},

		indexUpdate : function(){
			var thisObj = this;
			var items  = thisObj.get(thisObj.config.key);
			var objKeys = Object.keys(items);
			if( objKeys.length < 1){ return false; }
			
			var index = {}; // 인텍스 키값 
			var search = {}; 
			var count = 0;
			$.each(items,function(i,v){
				$.each(thisObj.config.index, function(si,sv){
					var key = v[sv];
					if( typeof index[sv] != 'object'){ index[sv] = {}; }				
					if( typeof index[sv][key] != 'object'){index[sv][key] = new Array() }
					index[sv][key].push(v.id);
				});
			});
			
			$.each(index, function(i,v){
				studentDB.set('std.'+i,v);				
			});

			// 마지막 pid 정보를 남겨준다. 
			var indexPidObjKeys = Object.keys(index['pid']);
			var info = {};
			info.totalCount = objKeys.length;
			info.lastPid = indexPidObjKeys[indexPidObjKeys.length-1];
			studentDB.set('std.info',info);				
		},

		// 데이터 추출
		get : function(key){
			try{
				var get = studentDB.get(key);
				if( typeof get != 'object') return {};
				return get;
			}catch(e){console.log(e); return  false}
		},

		view : function(){
			var thisObj = this;
			var itemsView = '';
			var items  = thisObj.get(thisObj.config.key);
			var itemsPid  = thisObj.get(thisObj.config.key+'.pid');
			var objKeys = Object.keys(itemsPid);
			if( Object.keys(items).length > 0){ 
				var itemTag = $('#item-list').val();
				for(var i = objKeys.length ; i > 0 ; i--){
					var id = itemsPid[objKeys[i-1]][0]; // pid 는 1개씩 만 존재한다.
					if( typeof thisObj.searchItems != 'undefined' && thisObj.searchItems.length > 0 ){
						if( $.inArray(id, thisObj.searchItems) == -1 ){ continue; }
					}
					var item = items[id];
					var subItem = itemTag;
					subItem = subItem.replaceAll('{학번}',item.id);
					subItem = subItem.replaceAll('{이름}',item.name);
					subItem = subItem.replaceAll('{나이}',item.age);
					subItem = subItem.replaceAll('{성별}',(item.gender == 'female' ? '여성':'남성'));
					subItem = subItem.replaceAll('{등록일}',item.reg);

					// 관리 링크를 가져온다.
					var btn =  '<a href="#none" onclick="return false;" class="event-delete btn gray">삭제</a>';
					btn +=  '<a href="#none" onclick="return false;" class="event-modify btn black">수정</a>';

					subItem = subItem.replaceAll('{관리}',btn);
					itemsView += subItem;
				}
			}
	
			$('.items').html(itemsView);
		},

		now : function(){
			let date = new Date();
			var item = {};
			item.year = date.getFullYear();
			item.month = ('0' + (date.getMonth() + 1)).slice(-2);
			item.day = ('0' + date.getDate()).slice(-2);
			item.hours = ('0' + date.getHours()).slice(-2);
			item.minutes = ('0' + date.getMinutes()).slice(-2);
			item.seconds = ('0' + date.getSeconds()).slice(-2);
			item.dateStr = item.year + '-' + item.month + '-' + item.day;
			item.timeStr = item.hours + ':' + item.minutes + ':' + item.seconds;			
			item.fullDateTimeStr = item.dateStr + ' '+item.timeStr;
			item.fullDateTime = item.year+''+item.month+''+item.day+''+item.hours+''+item.minutes+''+item.seconds;
			return item;
		},
		search : function(){
			var thisObj = this;
			var $form = $('#form-search');
			var $id = $form.find('[name="id"]');
			var $name = $form.find('[name="name"]');
			var searchItem = {
				id : $id.val(),	
				name : $name.val(),	
			};
			var item = thisObj.get(thisObj.config.key);

			if( searchItem.id == '' && searchItem.name == ''){  alert('검색어를 입력해주세요.'); return false; }

			var searchResult = new Array();
			var searchCount = 0;
			if( searchItem.id != ''){
				searchItem.id = parseInt(searchItem.id);
				searchCount ++;
				if( isNaN(searchItem.id) == true || !searchItem.id || parseInt(searchItem.id) < 1  ){ alert("올바른 학번을 입력해주세요(0보다큰 숫자만 입력가능)");  return false; }
				if( typeof item[searchItem.id] != 'undefined'){
					searchResult.push(searchItem.id);
				}
			}	


			if( searchItem.name != ''){
				searchCount ++;
				var itemName = thisObj.get(thisObj.config.key+'.name');
				if( typeof itemName[searchItem.name] != 'undefined'){
					var itemSearchName = itemName[searchItem.name]
					$.each(itemSearchName, function(i,v){
						v = parseInt(v);
						if( $.inArray(v,searchResult) == -1){
							if( searchCount > 1){
								var indexOf = searchResult.indexOf(v);
								searchResult.splice(v,1);
							}
							else{
								searchResult.push(v);
							}
						}
					});
				}
				else{
					searchResult = new Array();
				}
			}

			thisObj.searchItems = searchResult;
			if( thisObj.searchItems.length > 0 ){
				thisObj.view();
				$('.event-searchInit').show();
			}
			else{ alert("해당검색어로 일치하는 학생이 없습니다."); return false; }

		},
		searchInit : function(){
			var thisObj = this;
			var $form = $('#form-search');	
			var $id = $form.find('[name="id"]');
			var $name = $form.find('[name="name"]');
			$id.val('');
			$name.val('');
			thisObj.searchItems = new Array();
			$('.event-searchInit').hide();
			thisObj.view();
		},
		// 학생 삭제
		delete:function(id){
			var thisObj = this;
			var items  = thisObj.get(thisObj.config.key);
			if( typeof id == 'undefined' || !id || typeof items[id] == 'undefined'){ alert('학번을 찾을 수 없습니다.'); return false; }
			delete items[id];
			studentDB.set(thisObj.config.key,items);
			thisObj.indexUpdate(thisObj.config.key);

			// 아이템을 다시 추출 하여 전체 삭제일경우 깨끗하게 삭제
			items  = thisObj.get(thisObj.config.key);
			if( Object.keys(items).length < 1){ thisObj.allDelete();}
			thisObj.view();			
		},
		allDelete : function(){
			var thisObj = this;
			$.each(thisObj.config.index, function(si,sv){
				var key = thisObj.config.key+'.'+sv;
				studentDB.remove(key);
			});

			// 부가데이터 삭제
			studentDB.remove(thisObj.config.key);			
			studentDB.remove(thisObj.config.key+'.info');	

			thisObj.indexUpdate(thisObj.config.key);
			thisObj.view();			
		},
		modifyPopupOn : function(id){
			var thisObj = this;
			var items  = thisObj.get(thisObj.config.key);			
			if( typeof id == 'undefined' || !id || typeof items[id] == 'undefined'){ alert('학번을 찾을 수 없습니다.'); return false; }
			var $form = $('#form-modify');	
			var $id = $form.find('[name="id"]');
			var $name = $form.find('[name="name"]');
			var $age = $form.find('[name="age"]');
			var $gender = $form.find('[name="gender"]');

			$id.val(items[id].id);
			$name.val(items[id].name);
			$age.val(items[id].age);
			$gender.val(items[id].gender);

			$('body').addClass('modify-on');
		},
		modify : function(){
			try{
				var thisObj = this;
				var $form = $('#form-modify');
				var $id = $form.find('[name="id"]');
				var $name = $form.find('[name="name"]');
				var $age = $form.find('[name="age"]');
				var $gender = $form.find('[name="gender"]');
				var now = thisObj.now();
				var item = thisObj.config.defaultItem;
				var items  = thisObj.get(thisObj.config.key);
				var info  = thisObj.get(thisObj.config.key+'.info');
				item.id = $id.val();
				item.name = $name.val();
				item.age = $age.val();
				item.gender = $gender.val();
				item.reg = now.fullDateTimeStr;
				item.mod = typeof items.mod != 'undefined' && items.mod ? items.mod : '';

				if( item.id == ''){alert("학번을 입력해 주세요."); $id.focus(); return false; }
				if( item.name == ''){alert("학생이름을 입력해 주세요."); $name.focus(); return false; }
				if( item.age == ''){alert("학생나이를 입력해 주세요."); $age.focus(); return false; }
				if( item.gender == ''){alert("학생성별을 선택해 주세요."); $gender.focus(); return false; }

				if( isNaN(item.id) == true || !item.id || parseInt(item.id) < 1  ){ alert("학번 조회에 실패하였습니다."); $id.focus(); return false; }
				if( isNaN(item.age) == true || !item.age || parseInt(item.id) < 1 ){ alert("올바른 학생나이를 입력해주세요(0보다큰 숫자만 입력가능)"); $age.focus(); return false; }
				if( $.inArray(item.gender,['male','female']) < 0 ){ alert("올바른 학생성별을 입력해 주세요."); $age.focus(); return false;}

				item.id = parseInt(item.id);
				item.age = parseInt(item.age);
				if( typeof items[item.id] !== 'object'){
					alert('등록되지 않은 학생입니다.'); return false;
				}

				item.pid = items[item.id].pid;

				// 학생등록
				items[item.id] = item;
				studentDB.set(thisObj.config.key,items);
				thisObj.indexUpdate(thisObj.config.key);
				thisObj.view();
				thisObj.modifyPopupClose();
				alert('수정이 완료되었습니다.');

			}catch(e){
				console.log(e);
				return studentDB.error("수정에 실패하였습니다.",true);
			}			
		},
		modifyPopupClose : function(){

			var $form = $('#form-modify');	
			var $id = $form.find('[name="id"]');
			var $name = $form.find('[name="name"]');
			var $age = $form.find('[name="age"]');
			var $gender = $form.find('[name="gender"]');
			$id.val('');
			$name.val('');
			$age.val('');
			$gender.val('');
			$('body').removeClass('modify-on');
		},		
	}
	$(document).on('submit','#form-insert',function(){
		program.insert();
		return false;
	});
	$(document).on('submit','#form-search',function(){
		program.search();
		return false;
	});
	$(document).on('click','.event-insert',function(){
		var check = $('body').hasClass('insert-on');
		if( check == true){$('body').removeClass('insert-on'); }
		else{  $('body').addClass('insert-on'); }
		return false;
	});	
	$(document).on('click','.event-searchInit',function(){
		program.searchInit();
		return false;
	});
	$(document).on('click','.event-delete',function(){
		if( confirm('정말 삭제하시겠습니까?') == false){ return false;}
		var $item = $(this).closest('ul');
		var data = $item.data();
		program.delete(data.id);
		return false;
	});	
	$(document).on('click','.event-modify',function(){
		var $item = $(this).closest('ul');
		var data = $item.data();
		program.modifyPopupOn(data.id);
		return false;
	});		
	$(document).on('click','.event-modifySubmit',function(){
		program.modify();
		return false;
	});			
	$(document).on('click','.event-modifyClose',function(){
		program.modifyPopupClose();
		return false;
	});			
	$(document).on('click','.event-allDelete',function(){
		if( confirm('정말 전체삭제하시겠습니까?') == false){ return false;}
		program.allDelete();
		return false;
	});			
	$(document).on('click','.event-download',function(){
		var $this= $(this);
		var now = program.now();
		var filename = '학생관리프로그램-'+now.fullDateTime+'.json';
		var getItems = studentDB.get(program.config.key,true);
		var fileData = JSON.stringify(getItems);
		$this.attr('href','data:text/plain;charset=utf-8,'+encodeURIComponent(fileData));
		$this.attr('download',filename);
		return true;	
	});
	$(function(){
		program.indexUpdate();
		program.view();
	});
	</script>

  </body>
</html>

